require_relative 'validator'

class AuthProxy
  class Callback
    include AuthProxy::Validator

    def initialize(auth_options={}, host_options={})
      @auth_options = auth_options
    end

    def call(env)
      @env = env

      response = Rack::Response.new

      if valid_callback?
        response.set_cookie('secret', {path: '/', value: secret_cookie})
      end

      response.status = 301
      response['location'] = rack_request.base_url + '/'

      response.finish
    end

    private

    def secret_cookie
      auth_options.fetch(:secret, 'change_me')
    end

    attr_reader :env, :auth_options
  end
end
